#ifndef INCLUDED_CURVE_UTILITIES_H
#define INCLUDED_CURVE_UTILITIES_H

#pragma warning(disable : 4786)

class Point;

#ifdef WIN32
namespace CurveUtilities
{
	double binomialCoefficient(const unsigned int & n, const unsigned int & k);

	unsigned int factorial(const unsigned int & x);

	double raiseToIntegerPower(const double & x, const unsigned int & y);

	Point linearlyInterpolate(const Point & first_point, const Point & second_point, double t);
}
#else	// g++ doesn't implement namespace
extern double binomialCoefficient(const unsigned int & n, const unsigned int & k);

extern unsigned int factorial(const unsigned int & x);

extern double raiseToIntegerPower(const double & x, const unsigned int & y);

extern Point linearlyInterpolate(const Point & first_point, const Point & second_point, double t);
#endif

#endif